'Akwariowy kombajn
'Marcin Wizania
$noramclear
$regfile = "m8def.DAT"
Deflcdchar 1 , 17 , 31 , 29 , 23 , 27 , 21 , 14 , 32        'zdefiniowany znak
$crystal = 8000000

Config Watchdog = 2048
Start Watchdog
Config Timer1 = Timer , Prescale = 64
Config Lcdpin = Pin , Db4 = Portb.3 , Db5 = Portb.2 , Db6 = Portb.1 , Db7 = Portb.0 , E = Portb.4 , Rs = Portb.5
Config Lcd = 16 * 2
Config Servos = 1 , Servo1 = Portd.3 , Reload = 100
Config 1wire = Portc.0
Config Portb = Output
Config Pinc.1 = Input
Config Pinc.2 = Input
Config Pinc.3 = Input
Config Pinc.4 = Output
Config Pinc.5 = Input
Config Pind.2 = Input
Config Pind.0 = Input
Config Pind.1 = Output
Config Pind.3 = Output
Config Pind.4 = Output
Config Pind.5 = Output
Config Pind.6 = Output
Config Pind.7 = Output

Piezo Alias Portd.1
Al_led Alias Portc.4
Grzalka Alias Portd.5
Swiatlo Alias Portd.6
Pompka Alias Portd.7
S1 Alias Pind.0
S2 Alias Pinc.3
S3 Alias Pinc.2
S4 Alias Pinc.1
Akk Alias Pinc.5

Declare Sub D_pok
Declare Sub Wysw
Declare Sub Nac_s1
Declare Sub Nac_s2
Declare Sub Nac_s3
Declare Sub Read1820
On Timer1 Czas

Enable Interrupts
Enable Timer1

Dim Bd(9) As Byte
Dim X As Byte
Dim Licznik As Integer
Dim Sekund As Byte
Dim Minut As Byte
Dim Godz As Byte
Dim Tmp As Byte
Dim Temp1 As Byte
Dim Poziom As Bit
Dim Wyswietl As Bit
Dim Temp2 As Byte
Dim J As Byte
Dim Alarm As Byte
Dim Hist As Byte
Dim Zezw As Bit
Dim Temp3 As Byte
Dim Temp4 As Byte
Dim Temp5 As Byte
Dim Zm1(7) As Byte
Dim Zm2(4) As Byte
Dim Daj_pok As Byte
Dim T As Integer , T1 As Integer

Set Portd.2
Set Portd.0
Set Portc.1
Set Portc.2
Set Portc.3
Reset Portc.5
Minut = 0
Godz = 0
Licznik = 0
Zezw = 1
Hist = 1                                                    'zmienna okresla wielkosc histerezy w stopniach
Reset Piezo
Set Al_led

For J = 1 To 7                                              'odczytaj dane z pamieci eeprom
Readeeprom Zm1(j) , J
Next J
For J = 1 To 4
Temp1 = J + 7
Readeeprom Zm2(j) , Temp1
Next J

Cursor Off
Servo(1) = 10                                               'Ustaw pooenie servo
Start Timer1
                                        'Poczatek programu

Do
  If Akk = 1 Then                                           'jezeli stan na akk wysoki to wykonuj ponizsze instrukcje
    If S4 = 1 Then                                          'jezeli s4=1 to praca automatyczna
      If S2 = 0 Then                                        'jezeli s2=0 to wyzeruj falge zezwolenia na alarm dzwiekowy
        Reset Zezw
      End If
      If S1 = 0 Then                                        'jezeli s1=0 to wejdz do ustawien parametrow
        J = 1
        Waitms 200
        Bitwait S1 , Set
        Wyswietl = 1
        Do
          Call Nac_s1
          If J = 1 Then                                     'jezeli j=1 to ustaw temperature
            Temp2 = Zm1(j)
            Temp3 = 35
            Temp4 = 20
            If Wyswietl = 1 Then
              Cls
              Lcd "Temp:"
              Lcd Zm1(j)
            End If
          End If
          If J = 2 Or J = 3 Then                            'jezeli j=2 lub 3 to ustaw alarmy min oraz max
            Temp2 = Zm1(j)
            Temp3 = 40
            Temp4 = 15
            If Wyswietl = 1 Then
              Cls
              If J = 2 Then
                Lcd "Tmin:"
              Else
                Lcd "Tmax:"                                 'Przy j=3 wyswietla "Tmax"
              End If
              Lcd Zm1(j)
            End If
          End If
          If J > 3 And J < 8 Then                           'jezeli j=4 do j=7 ustaw pozostale parametry jak
            Temp3 = 25
            Temp4 = 0                                       'czasy wlaczaniai wylaczania dolaczonych
            Tmp = J - 3                                     'urzadzen
            Temp2 = Zm1(j)
            Temp5 = Zm2(tmp)
            Temp3 = 24
            Temp4 = 0
            Call Nac_s3
            Zm2(tmp) = Temp5
            If Wyswietl = 1 Then
              Cls
              If Tmp = 4 Then
                Lcd "L: "
              Else
                Lcd "P:"
                Lcd Tmp
              End If
              Lcd " on:"
              Lcd Zm1(j)
              Lowerline
              If J = 4 Then
                Lcd "    on:"
              Else
                Lcd "   off:"
              End If
              Lcd Zm2(tmp)
            End If
          End If
          If J = 8 Then
            Call Wysw
            Temp5 = Godz
            Temp3 = 23                                      'temp3 oraz temp4 okreslaja przedzial liczbowy jaki moga przyjnowac
            Temp4 = 0                                       'zmienne zapisane w temp5 i temp2
            Call Nac_s3                                     'podprogram zwiekszania godzin
            Godz = Temp5
            Temp2 = Minut
            Temp3 = 59
            Call Nac_s2                                     'podprogram zwiekszania minut
            Minut = Temp2
          Else
            Wyswietl = 0
            Call Nac_s2
            Zm1(j) = Temp2
          End If
        Loop Until J = 9                                    'jezeli j=8 to wyjdz z trybu konfiguracji parametrow sterownika
        For J = 1 To 7
          Writeeeprom Zm1(j) , J                            'zapisz ustawienia do pamieci eeprom
        Next J
        For J = 1 To 4
          Temp1 = J + 7
          Writeeeprom Zm2(j) , Temp1
        Next J
      End If
      If Daj_pok = 1 Then                                   'jezeli zgadza sie godzinazgodzina pokarmu to w przerwaniu od timer1 ustawiana
        Daj_pok = 0                                         'jest flaga daj_pok
        Call D_pok                                          'po czym wywolywany jest podprogram obslugi servo
      End If
    Else                                                    'Ponizej sa instrukcje wykonywane w trybie pracy recznym
      If S2 = 0 Then                                        'Jezeli nacisniety przycisk s2 to zmien stan przekaznika pompa na przeciwny
        Waitms 200
        Pompka = Not Pompka
        Bitwait S2 , Set
      End If
      If S1 = 0 Then                                        'Jezeli nacisniety s1 to podaj dawke pokarmu
        Call D_pok
        Bitwait S1 , Set
      End If
    End If
    Call Read1820                                           'procedura odczytu temperatury
    If S3 = 0 Then                                          'jezeli s3=0 to zmien stan przekaznika swiatlo na przeciwny
      Waitms 200
      Swiatlo = Not Swiatlo
      Bitwait S3 , Set
    End If
    Call Wysw                                               'wyswietl dane
    If Alarm = 0 Then                                       'jezeli zminna alarm=0 to ustaw flage "zezw"
      Set Zezw
    End If
    If Alarm <> 0 Then                                      'Jezeli alarm<>0 to wlacz alarm
      If Zezw = 1 Then                                      'jezeli flaga zezw ustawiona to wlacza takze
        Set Piezo                                           'alarm dzwiekowy
        Waitms 500
        Reset Piezo
      End If
      Reset Al_led
      Waitms 500
      Set Al_led
    End If
  Else                                                      'jezeli stan na akk niski to przejdz w stan idle
    Idle
  End If
Loop
End

Sub D_pok                                                   'Procedura dawkowania pokarmu
  Servo(1) = 20
  Wait 2
  Servo(1) = 10
End Sub

Sub Nac_s1                                                  'obsluga nacisniecia przycisku s1
  If S1 = 0 Then
    Waitms 100
    Incr J                                                  'zwieksz zmienna j
    Wyswietl = 1
    Bitwait S1 , Set
  End If
End Sub

Sub Nac_s2                                                  'obsluga nacisniecia przycisku s2
  If S2 = 0 Then
    Waitms 200
    Incr Temp2                                              'zwieksz zmienna temp2
    If Temp2 > Temp3 Then                                   'zastosuj ograniczenia przechowywane z zmiennych temp3 oraz temp4
      Temp2 = Temp4
    End If
    Wyswietl = 1
  End If
End Sub

Sub Nac_s3                                                  'obsluga nacisniecia przycisku s3
  If S3 = 0 Then
    Waitms 200
    Incr Temp5
    If Temp5 > Temp3 Then                                   'zastosuj ograniczenia
      Temp5 = Temp4
    End If
    Wyswietl = 1
  End If
End Sub

Sub Wysw                                                    'procedura obslugi wyswietlacza lcd 2*16 znakw
  If Wyswietl = 1 Then
    Cls
    If J = 8 Then
      Lcd "*"
    Else
      If S4 = 1 Then                                        'jezeli s4=1 to wyswietl "A" jako znacznik pracy automatycznej
        Lcd "A"
      Else
        Lcd "M"
      End If
    End If
    Locate 1 , 5
    Lcd "T=" : Lcd T                                        'Wyswietl zmierzona temperature
    Locate 1 , 12
    Temp1 = Makebcd(godz)                                   'wyswietl czas
    Lcd Bcd(temp1) ; ":"
    Temp1 = Makebcd(minut)
    Lcd Bcd(temp1)
    Locate 1 , 10
    If Poziom = 1 Then                                      'wyswietl poziom wody w akwarium
      Lcd "U"
      Lowerline
      Lcd "Al_P"                                            'pozostale instrukcje dbaja o wyswietlenia informacji o alarmach
    Else
      Lcd Chr(1)
    End If
    Lowerline
    If Alarm = 1 Then
      Lcd "Al_m"
    End If
    If Alarm = 2 Then
      Lcd "Al_x"
    End If
    Wyswietl = 0                                            'Zeruj flage wyswietl
  End If
End Sub

Czas:
  Reset Watchdog                                            'zeruj watchdoga
  Timer1 = 65411                                            'zaladuj timer odpowiednia waroscia
  Portd.4 = Not Portd.4                                     'podawaj przebieg na port d.4 potrzebny to badania poziomu wody
  If Portd.4 = 1 Then                                       'badaj stan lini d.2 w zaleznosci od stanu jaki panuje na linii d.4
    If Pind.2 = 1 Then                                      'jezeli odczytany stan jest wysoki to
      Set Poziom                                            'ustaw flage poziom
    Else                                                    ' w przeciwnym racie wyzeruj flage poziom
      Reset Poziom
    End If
  End If
  Incr Licznik                                              'zwieksz zmienna licznik
  If Licznik = 990 Then                                     'jezeli zmienna licznik osignie wartosc 990 to wyzeruj ja oraz
    Licznik = 0
    Incr Sekund                                             'zwieksz wartosc sekund
    Wyswietl = 1                                            'co sekunde ustawiaj zmienna wyswietl ktora umozliwia aktualizacje
    Alarm = 0                                               'wartosci na wyswietlaczu
    X = Zm1(1) - Hist                                       'porownaj temperature ustawiona ze zmierzona i steruj odpowiednio grzalka
    If T <= X Then
      Set Grzalka
    Else
      Reset Grzalka
    End If
    If Poziom = 1 Then                                      'Jezeli poziom wody jest maly to zaladuj do zmiennej alarm wartosc 3
      Alarm = 3
      Reset Zezw
    End If
    If T <= Zm1(2) Then                                     'jezeli zmierzona temperatura jest nizsza od ustawionej min temperatury
      Alarm = 1                                             'to zaladuj do alarm wartosc 1
    End If
    If T >= Zm1(3) Then                                     'Jezeli temperatura jest wieksza od ustawionej max to
      Alarm = 2                                             'to zaladuj do alarmu wartosc 2
    End If
    If Sekund = 60 Then
      Sekund = 0
      Incr Minut                                            'zwieksz wartosc minut
      If Minut = 60 Then
        Minut = 0
        Incr Godz                                           'zwieksz wartosc godzin
        If Godz = 24 Then
          Godz = 0
        End If
        If S4 = 1 Then
          If Zm1(7) = Godz Then                             'jezeli godzina sie zgadza to wlacz swiatlo
            Set Swiatlo
          End If
          If Zm2(4) = Godz Then                             'jezeli godzina sie nie zgadza to wylacz swiatlo
            Reset Swiatlo
          End If
          If Zm1(5) = Godz Or Zm1(6) = Godz Then            'jezeli godzina sie zgadza to wlacz pompke
            Set Pompka
          End If
          If Zm2(2) = Godz Or Zm2(3) = Godz Then            'jezeli godzina sie nie zgadza to wylacz pompke
            Reset Pompka
          End If
          If Zm1(4) = Godz Or Zm2(1) = Godz Then            'Jezeli godzinasie zgadza to podajdawke pokarmu
            Daj_pok = 1
          End If
        End If
      End If
    End If
  End If
Return

Sub Read1820                                                ' wystartuj pomiar
  1wwrite &HCC : 1wwrite &H44
  Waitms 350
  Disable Interrupts
  1wreset
  1wwrite &HCC                                              'odczytaj zmierzone dane o temperaturze
  1wwrite &HBE T
  Bd(1) = 1wread(9)
  1wreset
  Enable Interrupts
  Tmp = Bd(1) And 1
  If Tmp = 1 Then
    Decr Bd(1)
  End If
  T = Makeint(bd(1) , Bd(2))                                'przelicz otrzymane wyniki
  T = T * 50 : T = T - 25 : T1 = Bd(8) - Bd(7) : T1 = T1 * 100
  T1 = T1 / Bd(8) : T = T + T1 : T = T / 100
  Enable Interrupts
End Sub