'Dreczyciel sprzetu TV-AV
'Marcin Wizania
'marcin.wiazania@ep.com.pl


$crystal = 4000000                                          'czestotliwosc rezonatora kwarcowego

Config Portd = Input                                        'linie portu d jako wejscia
Config Portb = 00001000                                     'linia pb.3 portu b jako wyjscie, pozostale linie jako wejscia
Config Timer0 = Timer , Prescale = 1024                     'konfiguracja czasomierza 0 jako timer z preskalerem 1024
Config Aci = Off                                            'wylaczenie komparatora dla zmniejszenia poboru pradu
Config Watchdog = 1024                                      'konfiguracja watchdoga (odliczany czas ponad 1 sekunde)

On Timer0 Odlicz                                            'konfiguracja przerwania od przepelnienia timer0. Wywolana zostanie procedura oblicz co ponad 65 ms)

Dim Czas_sec As Word                                        'zmienna przechowujaca czas bezczynnosci dreczyciela
Dim Ustaw_zw As Byte                                        'zmienna przechowujaca ustawienia zworek
Dim Licz_p As Byte                                          'licznik przerwac od timer 0
Dim Sony_f As Bit                                           'flaga zezwolenia na nadanie kody w standardzie sony
Dim Rc5_f As Bit                                            'flaga zezwolenia na nadanie kody w standardzie rc5
Dim Rc6_f As Bit                                            'flaga zezwolenia na nadanie kody w standardzie rc6
Dim Temp As Word                                            'zmienna pomocnicza
Dim Address As Byte                                         'adres nadawanego kodu
Dim Command As Byte                                         'nadawany kod
Dim Togbit As Byte                                          'zmienna bitowa zwiazana z kodowaniem rc5 i rc6

Portd = 255                                                 'wlaczenie rezystorow podciagajacych do wszystkich linii portu d
Portb = 255                                                 'wlaczenie rezystorow podciagajacych dla linii wejsciowych portu B oraz ustawienie linii wyjsciowej pb.3 w stan wysoki

Enable Interrupts                                           'odblokowanie przerwan globalnych
Togbit = 0                                                  'wyzerowanie togbit
Reset Watchdog                                              'zerowanie licznika watchdog
Start Watchdog                                              'start licznika watchdog

Do                                                          'poczatek petli glownej programu
  Ustaw_zw = Pinb And &B00000111                            'zapisanie stanu zworek "czas" (trzech najmlodszych stanow linii portu b) do zmiennej ustaw_zw
  Select Case Ustaw_zw                                      'jezeli zmienna ustaw_zw ma
    Case 0 :                                                'wartosc 0 to
      Czas_sec = Rnd(901)                                   'zapisz do zmiennej czas_sec losowy czas z zakresu od 0 do 900 sekund (ok 15 min)
    Case 1 : Czas_sec = 30                                  'wartosc 1 to zapisz czas 30 sekund
    Case 2 : Czas_sec = 60                                  'wartosc 2 to zapisz czas 60 sekund
    Case 3 : Czas_sec = 120                                 'wartosc 3 to zapisz czas 120 sekund
    Case 4 : Czas_sec = 240                                 'wartosc 4 to zapisz czas 240 sekund
    Case 5 : Czas_sec = 360                                 'wartosc 5 to zapisz czas 360 sekund
    Case 6 : Czas_sec = 480                                 'wartosc 6 to zapisz czas 480 sekund
    Case 7 : Czas_sec = 600                                 'wartosc 7 to zapisz czas 600 sekund
  End Select                                                'koniec warunku
  Licz_p = 0                                                'zeruj zmienna licz_p
  Enable Timer0                                             'odblokowanie przerwan od timer0
  Do                                                        'petla do-loop
    Idle                                                    'wlacz tryb idle mikrokontrolera
  Loop Until Czas_sec = 0                                   'petla wykonywana az czas_sec rowne 0
  Disable Timer0                                            'zablokowanie przerwan od timer0
  Ustaw_zw.0 = Pind.5                                       'przepisz do bit 0 zmiennej ustaw_zw stan linii d.5
  Ustaw_zw.1 = Pind.4                                       'przepisz do bit 1 zmiennej ustaw_zw stan linii d.4
  Ustaw_zw.2 = Pind.6                                       'przepisz do bit 2 zmiennej ustaw_zw stan linii d.6
  Reset Sony_f                                              'zeruj flage sony_f
  Reset Rc5_f                                               'zeruj flage rc5_f
  Reset Rc6_f                                               'zeruj flage rc6_f
  Select Case Ustaw_zw                                      'jesli zmienna ustaw_zw
    Case 0 :                                                'Ma Wartosc 0 to
         Temp = Rnd(2)                                      'zapisz do temp wartosc losowa z zakresu 0..1
         If Temp = 1 Then                                   'jesli temp rowne 1 to
           Set Sony_f                                       'ustaw flage sony_f
         End If
         Temp = Rnd(2)                                      'zapisz do temp wartosc losowa z zakresu 0..1
         If Temp = 1 Then                                   'jesli temp rowne 1 to
           Set Rc5_f                                        'ustaw flage rc5_f
         End If
         Temp = Rnd(2)                                      'zapisz do temp wartosc losowa z zakresu 0..1
         If Temp = 1 Then                                   'jesli temp rowne 1 to
           Set Rc6_f                                        'ustaw flage rc6_f
         End If
    Case 1 :                                                'Ma Wartosc 1 to
      Set Sony_f                                            'ustaw flage sony_f
      Set Rc5_f                                             'ustaw flage rc5_f
      Set Rc6_f                                             'ustaw flage rc6_f
    Case 2 :                                                'Ma Wartosc 2 to
      Set Rc5_f                                             'ustaw flage rc5_f
    Case 3 :                                                'Ma Wartosc 3 to
      Set Rc6_f                                             'ustaw flage rc6_f
    Case 4 :                                                'Ma Wartosc 4 to
      Set Sony_f                                            'ustaw flage sony_f
    Case 5 :                                                'Ma Wartosc 5 to
      Set Sony_f                                            'ustaw flage sony_f
      Set Rc5_f                                             'ustaw flage rc5_f
    Case 6 :                                                'Ma Wartosc 6 to
      Set Rc5_f                                             'ustaw flage rc5_f
      Set Rc6_f                                             'ustaw flage rc6_f
    Case 7 :                                                'Ma Wartosc 7 to
      Set Sony_f                                            'ustaw flage sony_f
      Set Rc6_f                                             'ustaw flage rc6_f
  End Select                                                'koniec warunku
  Reset Watchdog
  If Rc5_f = 1 Then                                         'jesli flaga rc5_f ustawiona to
    Address = 0                                             'zeruj zmienna address
    Address.0 = Pinb.4                                      'przepisz do bit 0 zmiennej address stan linii b.4
    Address.1 = Pinb.5                                      'przepisz do bit 1 zmiennej address stan linii b.5
    Address.2 = Pinb.6                                      'przepisz do bit 2 zmiennej address stan linii b.6
    If Address = 0 Then                                     'jesli address rowne 0 to
      Temp = Rnd(32)                                        'losowanie do zmiennej temp liczby z zakresu 0..31
      Address = Low(temp)                                   'zapisanie do zmiennej address mlodszej czesci wylosowanych bitow zmiennej temp typu word
    Else                                                    'W Przesiwnym Wypadku
      Decr Address                                          'zmniejsz o jeden wartosc zmiennej address
    End If
      Command = Rnd(64)                                     'zapisz do zmiennej command (zmienna komendy) wartosc losowa z zakresu 0..64
      Rc5send Togbit , Address , Command                    'wyslanie kodu rc5 o adresie i komendzie zapisanych w zmiennych address i command
  End If
  Waitms 25                                                 'czekaj 25 ms

  If Rc6_f = 1 Then                                         'jesli flaga rc6_f ustawiona to
    Address = 0                                             'zeruj zmienna address
    Address.0 = Pinb.7                                      'przepisz do bit 0 zmiennej address stan linii b.7
    Address.1 = Pind.0                                      'przepisz do bit 1 zmiennej address stan linii d.0
    Address.2 = Pind.1                                      'przepisz do bit 2 zmiennej address stan linii d.1
    If Address = 0 Then                                     'jesli address rowne 0 to
      Temp = Rnd(32)                                         'losowanie do zmiennej temp liczby z zakresu 0..31
      Address = Low(temp)                                   'zapisanie do zmiennej address mlodszej czesci wylosowanych bitow zmiennej temp typu word
    Else                                                     'W Przesiwnym Wypadku
      Decr Address                                          'zmniejsz o jeden wartosc zmiennej address
    End If
    Command = Rnd(256)                                      'zapisz do zmiennej command (zmienna komendy) wartosc losowa z zakresu 0..255
      Rc6send Togbit , Address , Command                    'wyslanie kodu rc6 o adresie i komendzie zapisanych w zmiennych address i command
  End If
  Waitms 25                                                 'czekaj 25 ms
  Reset Watchdog                                            'zerowanie licznika watchdog

  If Sony_f = 1 Then                                        'jesli flaga sony_f ustawiona to
    Address = 0                                             'zeruj zmienna address
    Address.0 = Pind.2                                      'przepisz do bit 0 zmiennej address stan linii d.2
    Address.1 = Pind.3                                      'przepisz do bit 1 zmiennej address stan linii d.3
    If Address = 0 Then                                     'jesli address rowne 0 to
      Temp = Rnd(3)                                         'losowanie do zmiennej temp liczby z zakresu 0..2
      Address = Low(temp)                                   'zapisanie do zmiennej address mlodszej czesci wylosowanych bitow zmiennej temp typu word
    Else                                                    'W Przesiwnym Wypadku
      Decr Address                                           'zmniejsz o jeden wartosc zmiennej address
    End If
    If Address = 2 Then                                     'jesli address=2 to
       Address = 14                                         'zapissz do address 14
    End If
      Temp = Rnd(256)                                       'losowanie do zmiennej temp liczby z zakresu 0..255
      Shift Temp , Left , 4                                 'przesuniecie wartosci temp o 4 pozycje w lewo
      Temp = Temp + Address                                 'dodanie do zmiennej temp wartosc zmiennej address
      Sonysend Temp                                         'wyslanie wartosci zmiennej temp z uzyciem kodowania sony
  End If
  Waitms 25                                                 'czekaj 25 ms
Loop                                                        'koniec petli glownej programu
End                                                         'koniec programu

Odlicz:                                                     'poczatek przerwania od przepelnienia timer0
  Reset Watchdog                                            'zerowanie licznika watchdog
  Incr Licz_p                                               'zwieksz o jeden wartosc zmiennej licz_p
  If Licz_p = 16 Then                                       'jesli licz_p rowne 16 (odliczenie ponad 1 sekundy) to
    Licz_p = 0                                              'zeruj licz_p
    Decr Czas_sec                                           'zmniejsz o jeden wartosc zmiennej czas_sec
  End If
Return                                                      'powrot z procedury przerwania