'Program emuluje uproszczony bezprzewodowy wywietlacz LCD.
'Przykad konfiguracji moduu WT12 (praca jako ukd slave) do wppracy z moduem BT USB (emulacja portu COM)
'predkosc transmisji 115200 bodow
'Otrzymywane dane z komputerowego terminala po zatwierdzeniu przyciskiem ENTER,
's wywietlane w pierwszej linii wywietlacza LCD
'wysane do wywietlenia dane s potwierdzane komunikatem OK
'Wysanie znaku ESC powoduje kasowanie tekstu wywietlanego w pierwszej linii LCD

$regfile = "m88def.dat"                                     'informuje kompilator o pliku dyrektyw wykorzystywanego mikrontrolera
$crystal = 7372800                                          'informuje kompilator o czstotliwoci rezonatora kwarcowego
$baud = 115200

Config 1wire = Portc.0

Dim Temp As String * 6                                      'zmienna znakowa
Dim Znak As Byte                                            'zmienna znakowa
Dim On_off As Bit
Dim Temp_ds(2) As Byte
Dim Tmp As Byte
Dim T As Integer

Reset On_off
Wait 2                                                      'opnienie 2 sekundy
Print
Print "SET BT NAME BT-DS"                                   'nadanie nazwy moduowi  WT12
Waitms 100                                                  'opnienie 100ms
Print "SET PROFILE SPP ON"                                  'konfiguracja profili
Waitms 100                                                  'opnienie 100ms
Print "SET BT CLASS 001F00"                                 'nadanie klasy moduowi WT12
Waitms 100                                                  'opnienie 100ms
Print "SET BT AUTH * 1234"                                  'nadanie kodu PIN
Waitms 100                                                  'opnienie 100ms
Print "SET BT PAGEMODE 4 2000 1"                            'konfiguracja parametrw strony moduu WT12
Waitms 100                                                  'opnienie 100ms
Print "SET BT ROLE 0 F 7D00"                                'konfiguracja parametru ROLE
Waitms 100                                                  'opnienie 100ms
Print "SET CONTROL CD 04 0"                                 'konfiguracja kontroli sygnau CD (carriel detect)
Waitms 100                                                  'opnienie 100ms
Print "SET CONTROL ECHO 0"                                  'wyczenie Echo moduu WT12
Waitms 100                                                  'opnienie 100ms
Print "SET CONTROL ESCAPE 43 00 1"                          'konfiguracja znaku ESCAPE
Waitms 100                                                  'opnienie 100ms
Print "RESET"                                               'zerowanie moduu WT12
Wait 2                                                      'opnienie 2 sekundy

Do                                                          'nieskoczona ptla do-loop
  Znak = Inkey()
  If Znak = "t" Then
    Print Temp
  End If
  If Znak = "1" Then
    On_off = 1
  End If
  If Znak = "0" Then
    On_off = 0
  End If
  If On_off = 1 Then
    Print Temp
  End If
  1wreset                                                   'zerowanie magistrali 1wire
  1wwrite &HCC                                              'przeskoczenie numeru ukladu DS
  1wwrite &H44                                              'start pomiaru
  Waitms 900
  1wreset                                                   'zerowanie magistrali 1wire
  1wwrite &HCC                                              'przeskoczenie numeru ukladu DS
  1wwrite &HBE                                              'rozkaz odczytu temperatury
  Temp_ds(1) = 1wread(2)                                    'odczyt temperatury
  Tmp = Temp_ds(1) And 1                                    ' 0.1C precision
  If Tmp = 1 Then Decr Temp_ds(1)
  T = Makeint(temp_ds(1) , Temp_ds(2))
  T = T * 10
  T = T / 16
  Temp = Str(t)
  Temp = Format(temp , "0.0")
Loop                                                        'koniec nieskoczonej ptli
End                                                         'koniec programu