Sub Zapisz_vfd(byval Wart As Byte)                          'definicja procedury, ktora wysyla wartosc do VFD
  Reset Watchdog                                            'zerowanie watchdog
  Shiftout Portb.4 , Portb.5 , Wart , 1                     'wysyla wartosc do VFD
  Waitms 1                                                  'opoznienie 1 ms
End Sub                                                     'powrot z procedury

Sub Wys_zm_vfd                                              'wysyla zmienna do VFD
  Zm_lan = Str(j )                                          'przeliczenie zmiennej
  Wys_vfd Zm_lan                                            'wyslanie zmiennej do VFD
End Sub                                                     'powrot z procedury

Sub Jasn_zn(byval Js As Byte)                               'definicja procedury, ktra okrela jasno wywietlanych znakw
 Decr Js                                                    'zmniejszenie o jeden wartoci Js
 If Js < 8 Then                                             'jeli otrzymana warto Js < od 8, to
  Js = Js + &B00001000                                      'dodanie do wartoci Js kodu komendy okrelajcej jasno znakw VFD
  Call Zapisz_vfd(js)                                       'wys-anie wartoci Js do VFD
 End If
End Sub                                                     'powrot z procedury

Sub Poz_kurs(byval Poz As Byte)                             'definicja procedury, ktra okrela pozycj kursora
  Decr Poz                                                  'zmniejszenie o jeden wartoci parametru Poz
  If Poz < 16 Then                                          'jeli Poz < od 17, to
    Poz = Poz + &B11100000                                  'dodanie do wartoci Poz kodu komendy okrelajcej pozycj
    Call Zapisz_vfd(poz)                                    'wys-anie wartoci Poz do VFD
  End If
End Sub                                                     'powrot z procedury

Sub Wys_vfd(byval S As String)                              'definicja procedury, ktra wywietla podany jako parametr -acuch tekstu
 Local Dl As Byte                                           'lokalna zmienna okrelajca d-ugo tekstu w -acuchu
 Local Znak As String * 20                                  'lokalna zmienna tekstowa do ktrej bdzie zapisywany pojedynczy znak z -acucha tekstu
 Dl = Len(s)                                                'zwraca d-ugo tekstu ze zmiennej S do zmiennej Dl
 For M = 1 To Dl                                            'ptla tyle razy wykonana si, ile jest znakw w -acuchu tekstu
  Znak = Mid(s , M )                                        'zapisanie do zmiennej Znak jednego znaku z tekstu S o pozycji okrelonej przez M
  Kod = Asc(znak)                                           'zamiana znaku w zmiennej Znak na jej kod ASCII zapisywany w zmiennej Kod
  Zapisz_vfd Kod                                            'wys-anie kodu ASCII znaku do wywietlacza VFD
 Next M                                                     'zwikszenie o 1 wartoci M
End Sub                                                     'powrot z procedury

Sub Znak_uz(byval Nr_zn As Byte , Byval Kol1 As Byte , Byval Kol2 As Byte , Byval Kol3 As Byte , Byval Kol4 As Byte , Byval Kol5 As Byte)       'definicja procedury, ktra definiuje znak uytkownika
 Call Zapisz_vfd(255)                                       'wys-anie komendy definiowania nowego znaku
 If Nr_zn < 16 Then                                         'jeli Nr_zn jest < od 16, to
  Call Zapisz_vfd(nr_zn)                                    'zapisanie numeru znaku do VFD
  Call Zapisz_vfd(kol1)                                     'zapisanie kodu kolumny 1 znaku do VFD
  Call Zapisz_vfd(kol2)                                     'zapisanie kodu kolumny 2 znaku do VFD
  Call Zapisz_vfd(kol3)                                     'zapisanie kodu kolumny 3 znaku do VFD
  Call Zapisz_vfd(kol4)                                     'zapisanie kodu kolumny 4 znaku do VFD
  Call Zapisz_vfd(kol5)                                     'zapisanie kodu kolumny 5 znaku do VFD
 End If
End Sub                                                     'powrot z procedury

Sub Pocz()                                                  'definicja procedury, ktra ustawia kursor na pocztku linii VFD
  Poz_kurs 1                                                'wywo-anie procedury ustawiajcej kursor na 1pozycji VFD
End Sub                                                     'koniec procedury

Sub Czysc()                                                 'definicja procedury, ktra czyci zawarto VFD
 For M = 1 To 16                                            'ptla wykonywana 16 razy
  Poz_kurs M                                                'pozycja kursora na pozycj zawart w M
   Zapisz_vfd 32                                            'zapisanie na pozycji wskazywanej przez M znaku spacji
 Next M                                                     'zwikszenie M o 1
 Call Pocz                                                  'kursor na pocztek linii
End Sub                                                     'powrot z procedury

